diff -U 1 libxinevdec.patched_1.2_+_external-build/dshowserver.c libxinevdec/dshowserver.c
--- libxinevdec.patched_1.2_+_external-build/dshowserver.c	2008-08-04 09:52:41.000000000 +0000
+++ libxinevdec/dshowserver.c	2008-08-04 10:05:57.000000000 +0000
@@ -148,5 +148,2 @@
 	   buf->type, buf->decoder_flags);
-  
-  if (buf->decoder_flags & BUF_FLAG_PREVIEW)
-    return;
 
@@ -159,2 +156,5 @@
 
+  if (buf->decoder_flags & BUF_FLAG_PREVIEW)
+    return;
+
   if (buf->decoder_flags & BUF_FLAG_SPECIAL) {
@@ -286,8 +291,5 @@
 
-    if( (int) buf->size <= 0 )
-        return;
-       
     if( this->stream_id < 0 )
        this->stream_id = buf->type & 0xff;
-    
+
     if( this->stream_id != (buf->type & 0xff) )
@@ -295,4 +297,13 @@
 
-    xine_fast_memcpy (this->ds_mpi.data + this->size, buf->content, buf->size);
-    this->size += buf->size;
+    /* do not try to decode header buffers */
+    if (buf->decoder_flags & BUF_FLAG_HEADER)
+      return;
+  
+    if (buf->decoder_flags & BUF_FLAG_FRAME_START)
+      this->size = 0;
+  
+    if (buf->size > 0) {
+      xine_fast_memcpy (this->ds_mpi.data + this->size, buf->content, buf->size);
+      this->size += buf->size;
+    }
 
